*#-
*
*	We want to determine F in exp(A)*exp(B) = exp(F)
*	We do this via F = ln(exp(A)*exp(B))
*	For this we have to expand the exponents and afterwards the ln.
*
#define MAXPOW "14"
Functions A,B,C,D,EE,ln,exp,Take;
Symbols i,j,j1,j2,x(:`MAXPOW');
*Off Statistics;
Format Nospaces;
*
*	First we compute E = exp(A)*exp(B)-1
*
Local E = sum_(j1,0,`MAXPOW',x^j1*A^j1*invfac_(j1)
        *sum_(j2,0,`MAXPOW'-j1,x^j2*B^j2*invfac_(j2)
		))-1;
B	x;
#ifdef `TEST'
Print +f;
#endif
.sort
Hide E;
*
*	Now we need F = ln(1+E) = -sum_(j,1,`MAXPOW',sign_(j)*E^j/j)
*	This needs great care and we should select only the powers of x that will
*	lead to a result.
*
Local F = -sum_(j,1,`MAXPOW',sign_(j)*EE(j)/j);
repeat;
	id	EE(i?pos_)*x^j1? = sum_(j,1,`MAXPOW'-j1,x^j*Take(j))*x^j1*EE(i-1);
	id	EE(0) = 1;
endrepeat;
B	x;
.sort
Drop F;
#do i = 1,`MAXPOW'
Local F`i' = F[x^`i'];
#enddo
.sort
#$count = 1;
#do i = 1,1
	id,once,Take(j?) = E[x^j];
	if ( count(Take,1) ) redefine i "0";
	.sort: $count = `$count++';
#enddo
*
*	Next we would like to have commutators.
*
repeat;
	if ( count(C,1) == 0 ) id,once,B*A = A*B - C;
endrepeat;
.sort
#ifndef `TEST'
#do i = 1,1
	id,once,C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
	id,once,C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
	if ( match(C(?a)*D?{A,B}) ) redefine i "0";
	.sort
#enddo
#else
repeat id C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
.sort
#endif
id	C(?a,B,A) = C(?a,A,B);
#do i = 1,`MAXPOW'/2-2
.sort
repeat;
	if ( count(C,1) <= `i' ) id,once,B*A = A*B - C;
endrepeat;
.sort
#ifndef `TEST'
#do i = 1,1
	id,once,C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
	id,once,C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
	if ( match(C(?a)*D?{A,B}) ) redefine i "0";
	.sort
#enddo
#else
repeat id C(?a)*D?{A,B} = D*C(?a)-C(D,?a);
#endif
.sort
repeat id C(x?,?a)*D?{A,B,C} = D*C(x,?a)-C(D,x,?a);
repeat id	C(?a,C,?b) = C(?a,A,B,?b)-C(?a,B,A,?b);
id	C(?a,B,A) = C(?a,A,B);
.sort
repeat id,disorder,C(?a)*C(?b) = C(?b)*C(?a)-C(C(?b),?a);
.sort
repeat id,C(?a,C(D?(?d),?c),?b) = C(?a,D(?d),C(?c),?b)-C(?a,C(?c),D(?d),?b);
repeat id	C(?a,C,?b) = C(?a,A,B,?b)-C(?a,B,A,?b);
id	C(?a,B,A) = C(?a,A,B);
#enddo
.sort
id	C(?a) = D(?a)*C;
repeat;
	id	D(B,?a)*C(?b) = x*D(?a)*C(?b,B);
	id	D(A,?a)*C(?b) =   D(?a)*C(?b,A);
endrepeat;
id	D = 1;
.sort
On Statistics;

id	C(?a,A,B,A,A) = C(?a,B,A,A,A)/2+C(?a,A,A,A,B)/2;
id	C(?a,B,A,B,B) = C(?a,A,B,B,B)/2+C(?a,B,B,A,B)/2;
id	C(?a,B,B,A,A) = C(?a,A,A,B,B)-3*C(?a,A,B,A,B)+3*C(?a,B,A,A,B);

id	C(?a,A,A,A,A,A,B) = -(-5*C(?a,A,A,B,A,A,A)+6*C(?a,A,B,A,A,A,A)
						-2*C(?a,B,A,A,A,A,A));
id	C(?a,B,B,B,B,B,A) = -(-5*C(?a,B,B,A,B,B,B)+6*C(?a,B,A,B,B,B,B)
						-2*C(?a,A,B,B,B,B,B));
id	C(?a,A,A,A,A,B,B) = -(-4*C(?a,A,A,A,B,A,B)+6*C(?a,A,A,B,A,A,B)
			-4*C(?a,A,B,A,A,A,B)-C(?a,A,B,B,A,A,A)+C(?a,B,A,A,A,A,B)
			+2*C(?a,B,A,B,A,A,A)-C(?a,B,B,A,A,A,A));
*id	C(?a,B,B,B,A,A,B) = (+C(?a,B,B,B,B,A,A)+6*C(?a,B,B,A,B,A,B)
*			-4*C(?a,B,A,B,B,A,B)-C(?a,B,A,A,B,B,B)+C(?a,A,B,B,B,A,B)
*			+2*C(?a,A,B,A,B,B,B)-C(?a,A,A,B,B,B,B))/4;
id	C(?a,B,A,A,B,B,B) = -4*C(?a,B,B,B,A,A,B)+C(?a,B,B,B,B,A,A)
			+6*C(?a,B,B,A,B,A,B)
			-4*C(?a,B,A,B,B,A,B)+C(?a,A,B,B,B,A,B)
			+2*C(?a,A,B,A,B,B,B)-C(?a,A,A,B,B,B,B);
id	C(?a,A,A,B,B,A,B) = -(-2*C(?a,A,B,A,B,A,B)+2*C(?a,B,A,B,A,A,B)
			-C(?a,B,B,A,A,A,B));
id	C(?a,B,B,B,A,A,A) = (C(?a,A,A,A,B,B,B)-8*C(?a,A,B,A,A,B,B)
			+12*C(?a,A,B,A,B,A,B)-6*C(?a,A,B,B,A,A,B)
			+8*C(?a,B,A,A,A,B,B)-18*C(?a,B,A,A,B,A,B)
			+12*C(?a,B,A,B,A,A,B));
id	C(?a,B,B,A,A,A,B) = C(?a,A,A,B,B,A,B)-2*C(?a,A,B,A,B,A,B)
			+2*C(?a,B,A,B,A,A,B);

id	C(?a,A,B,A,A) = C(?a,B,A,A,A)/2+C(?a,A,A,A,B)/2;
id	C(?a,B,A,B,B) = C(?a,A,B,B,B)/2+C(?a,B,B,A,B)/2;
id	C(?a,B,B,A,A) = C(?a,A,A,B,B)-3*C(?a,A,B,A,B)+3*C(?a,B,A,A,B);

B	x;
*.sort
*CF	acc;
*Collect acc;
*MakeInteger acc;
Print +f +s;
.end
